package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[WFUser] 数据对象
 */
@TableName(value = "T_SRFWFUSER",resultMap = "WFUserResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFUser extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer isrecvwork;
    private String memo;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer recvinform;
    private String reserver;
    private String reserver2;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer validflag;
    @TableId(value= "wfuserid",type=IdType.UUID)//指定主键生成策略
    private String wfuserid;
    private String wfusername;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[是否接收工作]
     *  @param isrecvwork
     */
    public void setIsrecvwork(Integer isrecvwork){
        this.isrecvwork = isrecvwork;
        this.set("isrecvworkdirtyflag",true);
    }
    /**
     *  获取属性值[是否接收工作]
     */
    public Integer getIsrecvwork(){
        return this.isrecvwork;
    }
    /**
     *  重置属性值[是否接收工作]
     */
    public void resetIsrecvwork(){
        this.set("isrecvworkdirtyflag",false);
        this.isrecvwork = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[接收工作通知]
     *  @param recvinform
     */
    public void setRecvinform(Integer recvinform){
        this.recvinform = recvinform;
        this.set("recvinformdirtyflag",true);
    }
    /**
     *  获取属性值[接收工作通知]
     */
    public Integer getRecvinform(){
        return this.recvinform;
    }
    /**
     *  重置属性值[接收工作通知]
     */
    public void resetRecvinform(){
        this.set("recvinformdirtyflag",false);
        this.recvinform = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[有效标志]
     *  @param validflag
     */
    public void setValidflag(Integer validflag){
        this.validflag = validflag;
        this.set("validflagdirtyflag",true);
    }
    /**
     *  获取属性值[有效标志]
     */
    public Integer getValidflag(){
        return this.validflag;
    }
    /**
     *  重置属性值[有效标志]
     */
    public void resetValidflag(){
        this.set("validflagdirtyflag",false);
        this.validflag = null;
    }
    /**
     *  设置属性值[工作流用户标识]
     *  @param wfuserid
     */
    public void setWfuserid(String wfuserid){
        if(StringUtils.isEmpty(wfuserid))
            wfuserid=null;
        this.wfuserid = wfuserid;
        this.set("wfuseriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户标识]
     */
    public String getWfuserid(){
        return this.wfuserid;
    }
    /**
     *  重置属性值[工作流用户标识]
     */
    public void resetWfuserid(){
        this.set("wfuseriddirtyflag",false);
        this.wfuserid = null;
    }
    /**
     *  设置属性值[工作流用户名称]
     *  @param wfusername
     */
    public void setWfusername(String wfusername){
        if(StringUtils.isEmpty(wfusername))
            wfusername=null;
        this.wfusername = wfusername;
        this.set("wfusernamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户名称]
     */
    public String getWfusername(){
        return this.wfusername;
    }
    /**
     *  重置属性值[工作流用户名称]
     */
    public void resetWfusername(){
        this.set("wfusernamedirtyflag",false);
        this.wfusername = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetIsrecvwork();
        resetMemo();
        resetRecvinform();
        resetReserver();
        resetReserver2();
        resetUpdatedate();
        resetUpdateman();
        resetValidflag();
        resetWfuserid();
        resetWfusername();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFUser copyTo(WFUser targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFUser.class, WFUser.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfuserid();
		return targetEntity;
	}
}